'Unregister a type library (.TLB file).
'
'RUN THIS AS AN ADMIN USER (on Vista or later you will
'be prompted for elevation).
'
'Drag the TLB's icon onto the icon for this file, or
'execute it from a command prompt as in:
'
'          TLBUnreg.vbs fullpathtoTLBfile
'
'Based on:
'  Registering/Unregsitering TLB Files.
'  Created by Jason Bock, 05/04/1999
'  Original Idea Conceived by Bruce McKinney
'
Option Explicit

Private Const E_FAIL = &H80004005
Private Const TYPE_E_REGISTRYACCESS = &H8002801C
Private WinVer

Private Sub TLBAction()
  With CreateObject("TLI.TLIApplication")
    On Error Resume Next
    .TypeLibInfoFromFile(WScript.Arguments(0)).UnRegister
    If Err.Number = 0 Then
      MsgBox "Succeeded", vbOkOnly, WScript.ScriptName
    ElseIf Err.Number = E_FAIL Or Err.Number = TYPE_E_REGISTRYACCESS Then
      MsgBox "Already unregistered?", vbOkOnly, WScript.ScriptName
    Else
      MsgBox "Failed" & vbNewLine & vbNewLine _
           & "Unregistration error: " & Hex(Err.Number) _
           & ", " & Err.Description, _
             vbOkOnly, WScript.ScriptName
    End If
  End With
End Sub

With WScript.CreateObject("WScript.Shell")
  WinVer = .RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\CurrentVersion")
  If WScript.Arguments.Count < 1 Then
    MsgBox "No arguments.  Drag and drop the TLB file onto this script's icon."
  ElseIf WScript.Arguments.Count < 2 Then
    'One argument so we are the initial run.
    If Fix(CSng(WinVer)) < 6 then
      'Win2K or XP (run by admin user).
      TLBAction
    Else
      'Vista or later, run ourself again passing the TLB name and requesting elevation
      'passing a second (dummy) argument to let us know we're elevated on that run.
      With CreateObject("Shell.Application")
        .ShellExecute "wscript", _
                      """" & WScript.ScriptFullName & """ """ _
                    & WScript.Arguments(0) & """ ELEVATED", , "runas"
      End With
    End If
  Else
    'We have our arguments so we are the secondary, elevated run on Vista or later.
    TLBAction
  End If
End With
